* GetTrans.prg			(c) 1999 - 2000, Peisch Custom Software
*  Gets translations from Strings for whatever is passed in parameter

* This function is meant to work with Strings.Dbf and MsgSvc.Dbf from Steven Black's INTL Toolkit.
* These tables will be created by this function if they are not found on the current VFP path.
* Pass GetTrans the string, in your original laguage, which you want to have translated.  If the string
* is found in either Strings.dbf or MsgSvc.dbf with a translation for the current language, as defined
* by the INTL object, a translation is returned.  If you haven't instantiated the INTL object, or the string
* isn't found, the orginal string will be returned.  If the string is found, but there is no translation for the
* current language, the string for the original language is returned.  (Note in the case of records in MsgSvc,
* the string passed and the string from the original language aren't necessarily the same.)

* 11/10/99 - Original version

lparameter pString

local lOldAli, lTrans, lCurLanguage

if not file('msgsvc.dbf')
	messagebox('File MsgSvc.dbf is not found on the path and will be created.',64,'Missing file')
	create table MsgSvc (cKey C (60), cFunction C (60), cOriginal M, cSpanish M, cFrench M, cGerman M, cItalian M, ;
						cErrNo C (5), cAlignment C (1), cBell C (5), cRow C (3), cCol C (3), cVisual C (30), ;
						cGUIVisual C (60), cObject C (2), cTimeOut C (5), cTitle C (50), cRetType C (1), ;
						cWinFont C (25), cMacFont C (25), cWhere M)
endif
if not file('strings.dbf')
	messagebox('File Strings.dbf is not found on the path and will be created.',64,'Missing file')
	create table Strings (cOriginal M, cSpanish M, cFrench M, cGerman M, cItalian M, cWhere M)
endif

lOldAli = alias()

if type('_screen.ointl') = 'O'
	lCurLanguage = _screen.ointl.getlanguage()
else
	lCurLanguage = 'Original'
endif

use MsgSvc again in 0 alias TransltnsM
select 0
use Strings again alias TransltnsS

if not empty(pString)
	locate for alltrim(upper(cOriginal)) == alltrim(upper(pString))
	if found()
		if empty(lCurLanguage)
			lTrans = pString
		else
			if empty(eval('c'+alltrim(left(lCurLanguage,9))))
				lTrans = alltrim(eval('c'+left(lCurLanguage,9)))
			else
				lTrans = alltrim(cOriginal)
			endif
		endif
	else
		select TransltnsM
		locate for alltrim(upper(cKey)) == alltrim(upper(pString))
		if found()
			if empty(lCurLanguage)
				lTrans = pString
			else
				if not empty(eval('c'+alltrim(left(lCurLanguage,9))))
					lTrans = alltrim(eval('c'+left(lCurLanguage,9)))
				else
					lTrans = alltrim(cOriginal)
				endif
			endif
		else
			lTrans = alltrim(pString)
		endif
	endif
else
	lTrans = ''
endif

use in TransltnsS
use in TransltnsM

if not empty(lOldAli)
	select (lOldAli)
endif

return lTrans
*----------------------------------------------------------------------------------------------